import at.jku.ssw.In;
import at.jku.ssw.Out;
import at.jku.ssw.PrimeNumbers;

import at.jku.students.HashMap;

import java.util.ArrayList;

class HashMapTest {

  // TODO: Change to the version for your operating system
//  static final String FILENAME = "Top500.MacLinux.txt";
  static final String FILENAME = "Top500.Windows.txt";

  static final boolean DEBUG_OUTPUT = false;

  public static void main(String[] args) {
    test0();
    test1();
    test2();
    test3();
    if (DEBUG_OUTPUT) {
      test4();
    }
    test5();
  }

  static void test0() {
    Out.println("\n*** Test 0 *** \n");

    int n = 0;
    while (++n <= 100) {
      n = PrimeNumbers.nextPrime(n);
      Out.println(n);
    }
  }

  static void test1() {
    Out.println("\n*** Test 1 *** \n");

    HashMap m = new HashMap(0.95f);

    m.put("JKU", "0732/2468");
    m.put("Buergerservice Linz", "0732/7070");
    m.put("Linz AG", "0732/3400-4000");
    m.put("OEBB", "05-1717");

    makeDot("test1a.dot", m);

    m.put("JKU", "0732/2468-1111");
    m.put("JKU", "0732/2468-2222");
    m.put("JKU", "0732/2468-3333");
    m.put("JKU", "0732/2468-4444");
    Out.println("m.get(\"JKU\")=" + m.get("JKU")); // "0732/2468-4444"

    Out.println("m.containsKey(\"Linz AG\")=" + m.containsKey("Linz AG")); // true
    Out.println("m.containsKey(\"Energie AG\")=" + m.containsKey("Energie AG")); // false

    m.put("Energie AG", null);
    Out.println("m.containsKey(\"Energie AG\")=" + m.containsKey("Energie AG")); // true
    Out.println("m.get(\"Energie AG\")=" + m.get("Energie AG")); // null

    Out.println("m.remove(\"JKU\")=" + m.remove("JKU"));
    Out.println("m.containsKey(\"JKU\")=" + m.containsKey("JKU")); // false

    makeDot("test1b.dot", m);
  }

  public static void makeDot(String filename, HashMap map) {
    Out.open(filename);
    Out.print(map.makeDot());
    Out.close();
  }

  public static void makeDot(String filename, HashMap map, float width) {
    Out.open(filename);
    Out.print(map.makeDot(width));
    Out.close();
  }

  static void test2() {
    Out.println("\n*** Test 2 *** \n");

    HashMap m = new HashMap(0.9f);
    m.put("JKU", "0732/2468");
    m.put("Buergerservice Linz", "0732/7070");
    m.put("Linz AG", "0732/3400-4000");
    m.put("OEBB", "05-1717");

    Out.println("m.remove(\"Linz AG\")=" + m.remove("Linz AG"));

    m.put("Energie AG", "0800-81 8000");
    m.put("Sparkasse", "50-100-10100");

    Out.println("m.get(\"OEBB\")=" + m.get("OEBB")); // "05-1717"

    makeDot("test2.dot", m, 1.6f);
  }

  static void test3() {
    Out.println("\n*** Test 3 *** \n");
    HashMap m = new HashMap(.95f);
    Company[] companies = readCompanies(FILENAME);
    for (Company c : companies) {
      m.put(c.name, c);
    }

    makeDot("test3.dot", m, 3f);

    String[] names = {
      "Volkswagen", "Total", "Daimler", "Gazprom",
      "Panasonic", "Sony", "BMW", "Apple", "Coca-Cola",
      "Landesbank Baden-Wuerttemberg"};

    for (int i = 0; i < names.length; i++) {
      String name = names[i];
      Company c = (Company) m.get(name);
      Out.println(c.toString());
    }
  }

  static void test4() {
    Out.println("\n*** Test 4 *** \n");
    Company[] companies = readCompanies(FILENAME);
    for (int i = 0; i < companies.length; i++) {
      Company c = companies[i];
      System.out.println(String.format("%s: %d", c.name, c.name.hashCode()));
    }
  }

  static void test5() {
    HashMap m = new HashMap(1.0f);
    String[] keys = new String[26];
    for (char c = 'A'; c <= 'Z'; c++) {
      keys[c - 'A'] = Character.toString(c);
      m.put(keys[c - 'A'], null);
    }

    for (char c = 'A'; c <= 'Z'; c++) {
      Out.println("m.containsKey(\"" + keys[c - 'A'] + "\")=" + m.containsKey(keys[c - 'A']));
    }
  }

  static Company[] readCompanies(String filename) {
    In.open(filename);
    ArrayList<Company> result = new ArrayList<>();
    do {
      Company company = Company.readCompany();
      if (company != null) {
        result.add(company);
      }
    } while (In.done());
    In.close();
    return result.toArray(new Company[0]);
  }
}
